(* Uždavinys:   Laisvadieniai (laisvadieniai)
 * Olimpiada:   LIO'11
 * Etapas:      respublikinis
 * Grupė:       jaunesniųjų
 *
 * Autorius:    Linas Petrauskas
 *
 * Uždavinio sprendimas, atitinkantis oficialų sprendimo aprašymą.
 *
 *)

program laisvadieniai;

    const
        MAXM = 1000;

    var { uždavinio kintamieji }
        m, d, s, w, n : longint;
        svente        : array[0..MAXM - 1] of boolean;

function laisvadienis(y, i: longint): boolean;
begin
    if svente[i] or ((y * m + i) mod w >= d)
        then laisvadienis := true
        else laisvadienis := false;
end;

function laisvadieniu_metuose(y: longint): longint;
var
    i, kiek : longint;
begin
    kiek := 0;
    for i := 0 to m - 1 do
        if laisvadienis(y, i)
            then kiek := kiek + 1;
    laisvadieniu_metuose := kiek;
end;

function laisvadieniu_is_viso: longint;
var
    y, kiek, kartojasi : longint;
begin
    kiek := 0;
    y := 0;
    while y < n do
    begin
        kiek := kiek + laisvadieniu_metuose(y);
        y := y + 1;
        if (y * m) mod w = 0 then
        begin
            kartojasi := n div y;
            kiek := kiek * kartojasi;
            y := y * kartojasi;
        end;
    end;
    laisvadieniu_is_viso := kiek;
end;

    var { pagalbiniai kintamieji }
        i, j, k : longint;

begin
    {
    assign(input, 'laisvadieniai.in'); reset(input);
    assign(output, 'laisvadieniai.out'); rewrite(output);
    }

    readln(m, d, s);
    w := d + s;
    read(k);
    for i := 1 to k do
    begin
        read(j);
        svente[j - 1] := true;
    end;
    readln;
    readln(n);

    writeln(laisvadieniu_is_viso);
end.
