/* Uždavinys:   Raidės (raides-vyr)
 * Olimpiada:   LIO'2011
 * Etapas:      respublikinis
 * Grupė:       vyresniųjų
 *
 * Autorius:    Vytautas Gruslys
 */
#include <cstdio>
#include <cstdlib>

#define R_SK 'z' - 'a' + 1
#define MAX_N 20000
#define MAX_K 156

char raid[MAX_N];
int stulp[MAX_K][R_SK];
int N;

int main() {
    freopen( "raides-vyr.in", "r", stdin );
    freopen( "raides-vyr.out", "w", stdout );
    
    scanf( "%d", &N );
    scanf( "%s", &raid );
    
    int K = N;
    if( N > MAX_K ) K = MAX_K;
    
    int M = 0, ivert = -1;
    
    for( int m = 2; m < K; ++m )
    {
         for( int k = 0; k < m; ++k )
              for( int r = 0; r < R_SK; ++r )
                   stulp[k][r] = 0;
         
         int suma = 0;
         for( int i = 0; i < N; ++i )
         {
              suma += stulp[i % m][raid[i] - 'a'];
              ++stulp[i % m][raid[i] - 'a'];
         }
         
         if( suma >= ivert )
         {
             ivert = suma;
             M = m;
         }
    }
    
    printf( "%d %d\n", M, ivert );
    return 0;
}
